#ifndef glas_concept_is_sparse_vector_expression_hpp
#define glas_concept_is_sparse_vector_expression_hpp

#include <glas/concept/concept.hpp>
#include <glas/concept/template_for_is.hpp>
#include <glas/concept/sparse_vector_expression_concept.hpp>
#include <boost/mpl/or.hpp>
#include <boost/mpl/if.hpp>
#include <boost/mpl/bool.hpp>
#include <boost/mpl/front.hpp>
#include <boost/mpl/pop_front.hpp>
#include <boost/mpl/empty.hpp>
//#include <boost/type_traits/remove_const.hpp>

namespace glas {

  namespace detail {

    template <class T>
    struct is_sparse_vector_expression_aux
    : template_for_is< T, is_sparse_vector_expression_aux >
    {} ;

    template <>
    struct is_sparse_vector_expression_aux< sparse_vector_expression_concept >
    : boost::mpl::true_
    {} ;

  } // namespace detail


  template <class T>
  struct is_sparse_vector_expression
  //: detail::is_sparse_vector_expression_aux< typename concept<typename boost::remove_const<T>::type>::type >
  : detail::is_sparse_vector_expression_aux< typename concept<T>::type >
  {} ;

}

#endif
